(* state.mli *)

open Proof
open Sequent
open Formule

type state
type tactic = sequent -> state

exception Invalid_tactic of string

val nb_buts : state -> int
val but : state -> sequent

val start : sequent -> state
val finish : state -> proof
val apply : tactic -> state -> state
val focus : int -> state -> state

val tac_assume : tactic
val tac_axiom : tactic
val tac_aff : id -> tactic
val tac_and_l : id -> id -> id -> tactic
val tac_and_r : tactic 
val tac_or_l : id -> id -> id -> tactic
val tac_or_r1 : tactic
val tac_or_r2 : tactic
val tac_imply_l : id -> id -> tactic
val tac_imply_r : id -> tactic
val tac_neg_l : id -> tactic
val tac_neg_r : id -> tactic
val tac_cut : id -> formule -> tactic
val tac_abs : id -> tactic

val tac_skip : tactic

val tac_comp : tactic -> tactic -> tactic
val tac_cond : tactic -> tactic -> tactic
val tac_repeat : tactic -> tactic
