(* sequent.ml *)

open Formule

type id = string
type sequent = ( id*formule ) list * formule

let eq_hyp h1 h2 =
	( List.sort compare h1 ) = ( List.sort compare h2 )
	
let print_sequent o ( h, c ) = 
	let rec print_list o = function
		| [] -> Printf.fprintf o "[]" 
		| [ ( id, f ) ] -> Printf.fprintf o "%s:\"%a\"" id print_formule f
		| ( id, f ) :: q ->
			Printf.fprintf o "%s:\"%a\", %a" id print_formule f print_list q
	in Printf.fprintf o "%a |- %a" print_list h print_formule c
	
let latex_print_sequent o ( h, c ) = 
	let rec print_list o = function
		| [] -> Printf.fprintf o " " 
		| [ ( _, f ) ] -> Printf.fprintf o "%a" latex_print_formule f
		| ( _, f ) :: q ->
			Printf.fprintf o "%a, %a" print_list q latex_print_formule f
	in Printf.fprintf o "%a \\vdash %a" print_list h latex_print_formule c
